/*!
\file sphere3d.h
\brief Class declaration for  Sphere3D
\author Nicholas Phillips, phillips@friday.gsfc.nasa.gov
\date Aug 11, 2004
*/
#ifndef SPHERE3D_H
#define SPHERE3D_H
#include <vector>
#include "projection.h"
#include "face.h"

//=======================================================================
class Sphere3D : public Projection
{
public:
    Sphere3D();

    virtual ~Sphere3D();
    virtual void draw();
	void setResolution(int sphere_res_);
	virtual bool select(const qglviewer::Vec &o,const qglviewer::Vec &d, qglviewer::Vec &v);
protected:
	int sphere_res;		//!< The current resolution of the 3D sphere
	int nside;
	std::vector<Face> faces;
	typedef std::vector<Face>::iterator FI;
	std::vector<double> costhetas_np;	//!< theta values for North Pole Faces
	std::vector<double> costhetas_eq;	//!< theta values for Equatorial Pole Faces
	std::vector<double> costhetas_sp;	//!< theta values for South Pole Faces

protected:
	void drawFace(const int face);
	void setThetas();

};

#endif
